// this interface goal structure.
package clarion.acs.gs;
import java.util.Vector;

/** This class provides an interface of goal structure. It is the base class
 *  for goal structure and the concrete goal structure. */
public interface GoalStructure{

   /** Returns if the goal structure is empty or not. */
   public boolean isEmpty();
   /** Returns the number of goal items. */
   public int getSize();
   /** Returns the currently active goal in terms of index. */
   public int getActiveGoal();
   /** Returns the currently active goal item in terms of a chunk. */
   public GoalChunk getActiveItem();
   /** 'set' action. */
   public boolean actionSet( int idx );
   /** 'reset' action. */
   public boolean actionReset(int idx );
   /** 'no goal' action. */
   public boolean actionNoGoal();
   /** routine when the currently active goal is finished. */
   public void goalFinished( boolean popFlag );
   /** Updates the goal structure with current state. */
   public void updateState( double[] state );
}