/********************* GET INSTRUCTIONS TEXT  ********************************/
package clarion.common;
import main.ClarionMain;

 /** This class is to show instructions and rights of software information on the
   * screen. */

public class InstrText {

  public final static int ROWS = 20, COLS = 55;
  private static String rightReserveInfo =
    "( Do not distribute or duplicate. All rights reserved. )";
/**
 private String[] taskInstructions = {
           "               Instructions:               \n" +
          "                                                              \n" +
          "1. The upper-right text area allows you to input a  number    \n" +
          "   indicating how many blocks you want to train. You  should  \n" +
          "   input an integer ranging from 1 to 1000, otherwise a dialog\n" +
          "   box will be shown indicating an input error. By default,   \n" +
          "   the block number is 20.                                    \n" +
          "2. The mid-right text area is to show the file name you chose \n" +
          "   or created from your hard disk to save the training data . \n" +
          "3. The button ENTER will be enabled if both of above are done \n" +
          "   correctly, and when pushed, lets you enter into the experiment\n" +
          "4. The button SELECT FILE, when pushed,lets you select or create \n" +
          "   a file as explained in  2.                                    \n" +
          "5. When the button EXIT is pushed, the entire program will exit. \n" +
          "6. The button \"by human \" indicates the task is to be controlled" +
          "   by human subjects. The button \"by Clarion\" indicates the task" +
          "   is to be controlled by CLARION. The button \"by ACT-R\" indicates" +
          "   the task is to be controlled by ACT-R.                        \n" +
          "7. When the button \" CLARION SETTING\" is pushed, it will enter \n" +
          "   CLARION model environment which is similar to the first screen.\n" +
          "8. In the training screen, first you should decide whether you \n" +
          "   want to show the parameter settings or not by pushing the   \n" +
          "   button SHOW SETTING, an option frame will be shown to let   \n" +
          "   you make a decision.                                        \n" +
          "9. The button EQUATIONS lets you select a kind of equation to  \n" +
          "   be trained, there are three kinds of equations: linear,     \n" +
          "   power and U-shape.                                          \n" +
          "10. The button PARAMETERS lets you select a pair of parameters \n" +
          "   for the equation you've selected.                           \n" +
          "11. The button BEGIN will be enabled if both equition type and \n" +
          "   parameters are selected, and when pushed, the\"Next Input\" \n" +
          "   list will be enabled and now you can select an input.      \n" +
          "12. The button BEGIN, when pushed, an initial pair of input and \n" +
          "   output will be generated randomly and shown on the screen.   \n" +
          "13. The button USE TIMER, when pushed, an option frame will be  \n" +
          "   shown to let you enable the timer or not.                    \n" +
          "14. The button TIME SETTING will be enabled when button USE TIMER\n" +
          "   is set to ON, and when pushed, an option frame will be shown  \n" +
          "   to let you set a time limit to each trial for the subjects.   \n" +
          "15. The button NOISE SETTING, when pushed, lets you set the ratio\n" +
          "   of each kinds of noises which will be considered  when        \n" +
          "   calculating the output p1.                                    \n" +
          "16. The button TARGET SETTING, when pushed, lets you set the     \n" +
          "   target level.                                                 \n" +
          "17.In the \"Next Input\"  list shown on the left side of the  \n" +
          "   window,, you can use a mouse to select a value from it and \n" +
          "   the  value will be shown on the \"trial 1\" in the part of \n" +
          "   window showing the current input and the corresponding     \n" +
          "   output will be produced  and shown above the  \"trial 1 in \n" +
          "   in the part of window showing the current output.          \n" +
          "18. You can select one by one and corresponding data will be   \n" +
          "   shown on  the  proper areas just the same as step 17 says  \n" +
          "   until you have 10 trials.                                  \n" +
          "19. When finishing one block ( 10 trials ), a dialog will  be  \n" +
          "   shown  to inform you  enter the  next  block. some parts of \n" +
          "   windows will be cleared and wait for your next block of    \n" +
          "   training.                                                  \n" +
          "20. when the number of block you have tried reaches the number \n" +
          "   you expected, a dialog box will be  shown to inform you that  \n" +
          "   current session is terminated and the training data are saved \n" +
          "   to the file which you ever created or selected before. and    \n" +
          "   ask you if go to next section of training.                    \n" +
          "21. when you push the 'exit' button in this screen, all training \n" +
          "   data will be saved and the program will exit from the current \n" +
          "   screen and go back to the prevous screen.                  \n" +
          "22. The 'x' button located in top-right corner of the windows, \n" +
          "   belongs to the Java platform and its function is to close   \n" +
          "   the window. When pushed, all the training data will be saved \n" +
          "   if exist, and the entire program will exit.                \n" +
          "23. All the training data include the initial randomly generated \n" +
          "   data.                                                      \n" +
          "24. The data file is in a text format and can be read by word or \n" +
          "   wordpad in windows and vi in unix and linux and other text \n" +
          "   viewers can also read it. Notepad has some problem viewing \n" +
          "   it.                                                        \n",
          "LC task instructions",
          "TH task instructions",
          "CI task instructions",
          "DS task instructions",
          "AGL task instructions"
      };
 */

  private static String mainInstruction =
      "                Instructions For Configuration and Run         \n\n" +
      "1. Generally, there are seven steps in a logic order to allow  \n" +
      "   you to configure and run a task simulation using this newly \n" +
      "    designed interface.       \n\n" +
      "2. You have one focus at one time and should confirm your selection\n" +
      "   at current step before you can move to the next step. Everytime,\n" +
      "   there is only one step is hightlighted and enabled which allows \n" +
      "   you to make a selection and the other steps are disabled which  \n" +
      "   prevents you from doing selection.                             \n\n" +
      "3. This new interface is more guidable than old version and makes \n" +
      "   the flow control easy to implement and maintain. It removes    \n" +
      "   user's randomness of selecting across steops with potential    \n" +
      "   inter-dependency which makes the situatoin more complicated.   \n" +
      "   In the following, we will introduce the seven steps in details \n" +
      "   step by step.                                                  \n\n" +
      "4. The task configuration has two parts, one for CLARION itself   \n" +
      "   configuration if you want CLARION to simulate your task and the \n" +
      "   other is task-specific configuration. The CLARION configuration \n" +
      "  is opitonal and the task-specific is mandatory.                  \n\n" +
      "5. To make the process of configuration much more easier. We       \n" +
      "   strongly recommend you to write a configuration template for    \n" +
      "   your task which is composed by a set of normal files in .txt    \n" +
      "   format which contents conform to format CLARION defines. Once   \n" +
      "   you finish it and put them in the proper directory and in the   \n" +
      "   proper hierarchy CLARION defines. See manual on the details.    \n" +
      "   Also there are many samples of such configuration files, see    \n" +
      "   them to get a better and deeper knowledge.                     \n\n" +
      "6. The reason why the above template is recommonded because it is  \n" +
      "   a fast way of configuration once you know well the pre-defined  \n" +
      "   format which actually is very easy to grasp. Base on this       \n" +
      "   template, you can derive various variations as many as you want.\n" +
      "   The configuration of CLARION itself is very complicated if start \n" +
      "   from scratch without a template at hand. Once you have a template \n" +
      "   for your task at your hand. the configuration become much easier: \n" +
      "   you can load it from files to GUI frames when you are in        \n" +
      "   'configure with GUI' mode, then tailor it for configuration of  \n" +
      "   each particular agent. Another reason is that although the      \n" +
      "   system can provide you a default configuration automatically for\n" +
      "   your task in the case that you don't have a particular tempalte \n" +
      "   for your task and sometimes it can reduce your work significantly\n" +
      "   if your task is not very compliated, it is far from being ccurate\n" +
      "   for you own task and it has still a lot to do.                 \n\n" +
      "7. Step 1 : You need to input an eligible number of agents running \n" +
      "   simultaneously from 1 to 100 in the text field and confirm it by \n" +
      "   clicking the corresponding 'confirm' button on the right side. \n" +
      "   This is important configuration parameter because current new  \n" +
      "   version allows multiple agents run simultaneously. Make sure your \n" +
      "   task should run in a mutiple-agents mode. In the further steps, \n" +
      "   the system will create a package of GUI frames for you to       \n" +
      "   configure every agent's individual characteristics according to \n" +
      "   this number you provide.                                       \n\n" +
      "8. Step 2. Control mode seleciton. You need to make a decision on  \n" +
      "   simulaiton control between 'BY HUMAN', 'BY CLARION' AND 'BY ACT-R'.\n" +
      "   'BY CLARION' is focus of this step and also the overall software \n" +
      "   system. 'BY CLARION' means the task will be simulated based on   \n" +
      "   CLARION cognitive model. 'BY ACT-R' means the task will be       \n" +
      "   simulated based on ACT-R model which is not implemented yet in   \n" +
      "   current version. 'BY HUMAN' means the task will be run by        \n" +
      "   simulating human's behaviors in the experiement which is task-   \n" +
      "   specific and only Proccess Control Task is implemented for       \n" +
      "   function. Once your decision is made, then user the 'confirm'    \n" +
      "   button on the right side to confirm. The following Step 5 of     \n" +
      "   CLARION configuration by GUI be depended on the selection on this\n" +
      "   step.                                                          \n\n" +
      "9. Step 3. Configuration mode selection. In this step, you need to  \n" +
      "   choose 'configure with GUI' or 'configure without GUI' to        \n" +
      "   implement your task configuration. When you select the former,   \n" +
      "   a package of GUI frames will be provided in the further stesp to \n" +
      "   allow you to configure your task more visually. And when you     \n" +
      "   select the latter, you need to do more program work in advance.  \n" +
      "   See Manual on the details of know how to do it using this mode.  \n" +
      "    Also, reference the instruction 4, 5, 6. Confirm your decision  \n" +
      "    by the 'confirm' button on the right side.                      \n\n" +
      "10. Step 4. task-specific configuration with GUI. To do it, click the\n" +
      "    button 'Go To Task Specific GUI'. Then you will be provided a    \n" +
      "    GUI frame which is the main interface for your task specific     \n" +
      "    configuration. Currently, this part of configuration is much     \n" +
      "    simpler than the CLARION configuration. Confirm your             \n" +
      "    configuration by clicking the 'confirm' button on the right side.\n\n" +
      "11. Step 5. CLARION configuration with GUI. It is the most important \n" +
      "    part of configuration process. Similar to the previous step, to  \n" +
      "    do it, click button 'Go To CLARION GUI'. Then you will be        \n" +
      "    provided a GUI frame which is the main interface for the CLARION \n" +
      "    configuration. Currently, this part is very complicated and time-\n" +
      "    comsuming. This part of interface is composed of 20 to 30 pages  \n" +
      "    in a hierarchical way according to the architecture of CLARION   \n" +
      "    modle. The exact number of pages is depended on your task.       \n" +
      "    Although the system has the powerful function for denpency check \n" +
      "    acroos different options, you still should be very careful about \n" +
      "    your choice of each option.  Again, confirm your configuration by\n" +
      "    clicking the 'confirm' button on the right side.            \n\n" +
      "12. One particular note should be paid enough attention to the  \n" +
      "    reentrant attribute of both parts of configurations. This   \n" +
      "    attribute allow you do reconfiguration by clicking the      \n" +
      "    corresponding button again. Once you reenter into the GUI, your \n" +
      "    previous work is automatically invalidated.                 \n\n" +
      "13. Step 6. Selection of output data file. Your final simulation data \n" +
      "    will be written into this file unless you provide some other  \n" +
      "    files in somewhere in your program code to override it. To do \n" +
      "    it, there are two ways. one is by clicking on the 'Select  \n" +
      "    Output File' button, this is a more visuable way. The other \n" +
      "    is to input an eligible file name in the text field below the \n" +
      "    the button. In the first way, once you are finished with an  \n" +
      "    file selected, the 'confirm' button is enabled for you to \n" +
      "    confirm it. At the same time, the file name is shown in the text\n" +
      "    field and then the text field becomes not editable and disabled.\n" +
      "    In the second way, you can alos enable the 'confirm' button by  \n" +
      "    input a ENTER key after an eligible file name. Again, click   \n" +
      "    'confirm' button on the right side to confirm your file name. \n" +
      "    The data wil be stored in a text format and can be read by word \n" +
      "    or wordpad in windows and vi in unix and linux and other text \n" +
      "    viewers can also read it. Notepad has some problem viewing it. \n\n" +
      "14, Run your task, exit the system or goto step 1 by clicking the  \n" +
      "   corresponding buttons. Once yuor task is finished wiht running, \n" +
      "   you can go to step 1 to make anohter round of configuration and \n" +
      "   run process. This is particularly useful for the task with      \n" +
      "   different groups of agents indicating different experimental   \n" +
      "   conditions.. ";

   private static String[] taskInstructions = {
        "LC task instructions",
        "TH task instructions",
        "CI task instructions",
        "DS task instructions",
        "AGL task instructions"
  };

  public static String getRightReserveInfo()
  {
     return rightReserveInfo;
  }

  public static String getMainInstruction()
  {
     return mainInstruction;
  }

  public static String getTaskInstructions( String taskName )
  {
     for( int i = 0; i < ClarionMain.CLARION_TASK_TEXT.length; i++ )
          if( ClarionMain.CLARION_TASK_TEXT[i].equals( taskName ) )
              return taskInstructions[i];
     return taskName + " Instructions";
  }
}
