package clarion.nacs;
import clarion.system.*;
import clarion.common.*;

/**
 * <ul>
 * <li> General overview.
 * <ul>
 * <li> summary of this class <br>
 * This class is to implement the NACS samples in Episodic Memory. In this class,
 * each ACS sample contains two parts: input and output.
 * </ul>
 * <li> Role in the CLARION model <br>
 * This class implements NACS samples in EM and it makes easier the implementation of
 * assimulating AMN using these decomposed samples.
 * <li> Usage of this class. <br>
 * It is instantiated inside <em>EM</em> object.
 * </ul>
 * @author Xi Zhang
 */

public class EMNacsSample{

   /** the input part. */
   Chunk  input;
   /** the output part. */
   Chunk  output;

   /** constructor.
    *  @param input the input.
    *  @param output the output. */
   public EMNacsSample( Chunk input, Chunk output )
   {
      this.input = input;
      this.output = output;
   }

   /** Returns the part of input.
    *  @return the part of input. */
   public Chunk getInput()
   {
      return input;
   }

   /** Returns the part of output.
    *  @return the part of output. */
   public Chunk getOutput()
   {
      return output;
   }

   /** methods from class <em>Object</em> */
   public String toString()
   {
      String str = "the input = \n" + input;
      str += "the output = \n" + output;
      return str;
   }
}