package clarion.tools;
import clarion.system.*;

/** This class is to implement running CLARION in different configuraion settings. */

public class ParamSweeping{
  final double INC_VAL = 0.01;
  Global global;

  public ParamSweeping( Global g )
  {
     global = g;
  }

  public void setTemperature( int compIdx, int idx, int netIdx, int ruleType )
  {
     switch( compIdx ){
       case Global.ACS:
            switch( idx ){
              case 0:
                global.setIdnActionSelectionTemp( netIdx,
                       global.getIdnActionSelectionTemp(netIdx) + INC_VAL );
                break;
              case 1:
                global.setOverallActionSelectionTemp( netIdx,
                       global.getOverallActionSelectionTemp(netIdx) + INC_VAL );
                break;
              case 2:
                global.setARActionSelectionTemp( netIdx, ruleType,
                       global.getARActionSelectionTemp(netIdx,ruleType) + INC_VAL );
                break;
            }
            break;
       case Global.NACS:
            if( idx == 0 )
                global.setGksOutputTemperature( global.getGksOutputTemperature() + INC_VAL );
            else
                global.setAemTrainAcsOutputTemp( global.getAemTrainAcsOutputTemp() + INC_VAL );
            break;
     }
  }

  public void setThreshold( int compIdx, int idx, int netIdx, int ruleType )
  {
     switch( compIdx ){
       case Global.ACS:
            switch( idx ){
             case 0:
                global.setRerPosThreshold( netIdx, global.getRerPosThreshold(netIdx) + INC_VAL );
                break;
             case 1:
                global.setIrlPosThreshold( netIdx, global.getIrlPosThreshold(netIdx) + INC_VAL );
                break;
             case 2:
                global.setRerGenThreshold( netIdx, global.getRerGenThreshold(netIdx) + INC_VAL );
                break;
             case 3:
                global.setRerSpecThreshold( netIdx, global.getRerSpecThreshold(netIdx) + INC_VAL );
                break;
             case 4:
                global.setIrlDeleteThreshold( netIdx, global.getIrlDeleteThreshold(netIdx) + INC_VAL );
                break;
             case 5:
                global.setGoalActivationThreshold( global.getGoalActivationThreshold() + INC_VAL );
                break;
             case 6:
                global.setWmActivationThreshold( global.getWmActivationThreshold() + INC_VAL );
                break;
            }
            break;
       case Global.NACS:
            switch( idx ){
              case 0:
                 global.setThreshold_EM( global.getThreshold_EM() + INC_VAL );
                 break;
              case 1:
                 global.setThreshold_sim( global.getThreshold_sim() + INC_VAL );
                 break;
              case 2:
                 global.setAssocExtThreshold( global.getAssocExtThreshold() + INC_VAL );
                 break;
              case 3:
                 global.setChunkExtThreshold( global.getChunkExtThreshold() + INC_VAL );
                 break;
            }
            break;
       }
  }

  public void setProbability(int compIdx, int idx, int netIdx, int ruleType)
  {
     switch( compIdx ){
       case Global.ACS:
            global.setRerExtractionProb( netIdx, global.getRerExtractionProb(netIdx)+INC_VAL);
            break;
       case Global.NACS:
            switch( idx ){
               case 0:
                 global.setEmTrainAcsProb( global.getEmTrainAcsProb() + INC_VAL );
                 break;
               case 1:
                 global.setChunkEncodeProb( global.getChunkEncodeProb()+ INC_VAL );
                 break;
               case 2:
                 global.setAssocEncodeProb( global.getAssocEncodeProb() + INC_VAL );
                 break;
               case 3:
                 global.setAssocExtProb( global.getAssocExtProb() + INC_VAL );
                 break;
               case 4:
                 global.setChunkExtProb( global.getChunkExtProb() + INC_VAL );
                 break;
               case 5:
                 global.setAmnTrainedByEmProb( global.getAmnTrainedByEmProb() + INC_VAL );
                 break;
               case 6:
                 global.setAemTrainedByEmProb( global.getAemTrainedByEmProb() + INC_VAL );
                 break;
               case 7:
                 global.setAemTrainAcsProb( global.getAemTrainAcsProb() + INC_VAL );
                 break;
           }
           break;
     }
  }
}
