package tasksimulators.newsimu.PC;
import clarion.system.*;
import clarion.common.*;
import clarion.tools.*;
import clarion.acs.net.auxiliary.*;

public class IrlRuleFormPC implements IrlRuleForm {

      final int LEVEL_NUM = 12;
      int ruleSetIdx, a, b, c, target;
      int curAction, nextAction;

      public IrlRuleFormPC(){}

      public IrlRuleFormPC( int ruleSetIdx, int a, int b, int c, int target, int curAction )
      {
            this.ruleSetIdx = ruleSetIdx;
            this.a = a;
            this.b = b;
            this.c = c;
            this.target = target;
            this.curAction = curAction;
            nextAction = ( int ) ( target - b ) / a;
      }

      public double determineAction( short[] state, short[] exState, short[] gsState, short[] wmState,
                                     short[][][] suggestedAction )
      {
         int p1 = 0;
         for( int i = 0; i < state.length; i++ )
              if( state[i] == 1 ){
                  p1 = i;
                  break;
              }
         // action in new format.
         short[][] action = new short[1][1];
         int chosenAction = Math.round( ( target - c * p1 - b ) / a );
         if ( chosenAction < 0 )
              chosenAction = 0;
         else if ( chosenAction > LEVEL_NUM - 1 )
                   chosenAction = LEVEL_NUM - 1;
         switch( ruleSetIdx ){
             case 0:  // action should be returned for this step.
             case 1:
                  curAction = chosenAction;
                  break;
             case 2:  // action should be returned for next step.
             case 3:
                  curAction = nextAction;
                  nextAction = chosenAction;
                  break;
         }
         action[0][0] = (short)curAction;
         suggestedAction[Global.ACTION_NORMAL] = CommonMethods.copy( action );
         return 1.0;
      }

      public void generalize()
      {
      }

      public void specialize()
      {
      }
}